unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, Grids, DBGrids, IBDatabase, IBCustomDataSet, IBTable,
  StdCtrls;

type
  TForm1 = class(TForm)
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBTable1: TIBTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Jn
procedure TForm1.Button1Click(Sender: TObject);
var
   AppPath : string ;
begin
   AppPath := ExtractFilePath(Application.ExeName);

   if (IBTable1.Active) then
      IBDatabase1.ApplyUpdates([IBTable1]);

   IBTable1.Active := False ;
   IBTransaction1.Active := False ;
   IBDatabase1.Connected := False ;

   // f[^x[X쐬
   IBDataBase1.DatabaseName := AppPath + 'TEST.FDB' ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER "SYSDBA"');
   IBDatabase1.Params.Add('PASSWORD "masterkey"');
   IBDatabase1.Params.Add('PAGE_SIZE 4096');
   try
      IBDataBase1.CreateDatabase;
   except
      // ɍ쐬ς
   end;

   // f[^x[Xڑ
   IBDataBase1.DatabaseName := AppPath + 'TEST.FDB' ;
   IBDataBase1.Connected := False ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER_NAME=SYSDBA');
   IBDatabase1.Params.Add('PASSWORD=masterkey');
   IBDatabase1.Connected := True ;
   IBTransaction1.Active := True ;

   // e[u쐬
   try
      with IBTable1 do begin
         TableName := 'TEST' ;
         if not(IBTable1.Exists) then begin
            StoreDefs := True ;
            // e[u̍
            with FieldDefs do begin
               Clear;
               with AddFieldDef do begin
                  Name := 'N';
                  DataType := ftInteger ;
                  Required :=True;
               end;
               with AddFieldDef do begin
                  Name := 'MOJIDATA';
                  DataType := ftString ;
                  Size := 20 ;
               end;
            end;
            // CfbNX
            with IndexDefs do begin
               Clear;
               with AddIndexDef do begin
                  Name := 'INDEX1';
                  Fields := 'N';
               end;
            end;
            //
            CreateTable;
         end;
      end;
   except
      ;
   end;
   IBTable1.StoreDefs := False ;
   IBDatabase1.Connected := False ;

   // ڑ
   IBDatabase1.Connected := True ;
   IBTransaction1.Active := True ;
   IBTable1.Active := True ;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if (IBTable1.Active) then
      IBDatabase1.ApplyUpdates([IBTable1]);

   IBTable1.Active := False ;
   IBTransaction1.Active := False ;
   IBDatabase1.Connected := False ;
end;

end.
